SystemOrganization addCategory: #'ARDrone-Core'!
SystemOrganization addCategory: #'ARDrone-Etoys'!

Player subclass: #ARDronePlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARDrone-Etoys'!

!ARDronePlayer methodsFor: 'drone-connect' stamp: 'Richo 8/7/2012 17:27'!
connect
	^ self sendMessageToCostume: #connect! !

!ARDronePlayer methodsFor: 'drone-connect' stamp: 'Richo 8/7/2012 17:27'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!ARDronePlayer methodsFor: 'drone-movement' stamp: 'Richo 8/7/2012 17:28'!
emergency
	^ self sendMessageToCostume: #emergency! !

!ARDronePlayer methodsFor: 'drone-connect' stamp: 'Richo 8/7/2012 17:27'!
getIsConnected
	^ self sendMessageToCostume: #isConnected! !

!ARDronePlayer methodsFor: 'drone-movement' stamp: 'Richo 8/7/2012 17:28'!
land
	^ self sendMessageToCostume: #land! !

!ARDronePlayer methodsFor: 'drone-movement' stamp: 'Richo 8/7/2012 17:28'!
takeOff
	^ self sendMessageToCostume: #takeOff! !

Morph subclass: #ARDroneMorph
	instanceVariableNames: 'rotors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARDrone-Etoys'!

ARDroneMorph class
	instanceVariableNames: 'outdoorForm indoorForm form'!

ARDroneMorph class
	instanceVariableNames: 'outdoorForm indoorForm form'!

!ARDroneMorph class methodsFor: 'viewer categories' stamp: 'Richo 8/7/2012 17:23'!
additionsToViewerCategories
^ #(

(#'drone - connection' (
#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
))

(#'drone - movement' (
#(command takeOff '' )
#(command emergency '' )
#(command land '' )
))


)! !

!ARDroneMorph class methodsFor: 'parts bin' stamp: 'Richo 8/7/2012 17:25'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'ARDrone' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that lets you communicate with an ARDrone' translatedNoop! !

!ARDroneMorph class methodsFor: 'form' stamp: 'Richo 8/7/2012 15:13'!
form
	"
	form := nil
	"
	^ form ifNil: [self initializeForm]! !

!ARDroneMorph class methodsFor: 'form' stamp: 'Richo 8/7/2012 15:13'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAASkAAAEqCAYAAABJDaYsAAAABHNCSVQFBQUBSsjp7wAAihNJ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='! !

!ARDroneMorph methodsFor: 'viewer category filter' stamp: 'Richo 8/7/2012 17:26'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!ARDroneMorph methodsFor: 'connection' stamp: 'Richo 8/7/2012 17:25'!
connect
	self flag: #Richo! !

!ARDroneMorph methodsFor: 'geometry testing' stamp: 'Richo 8/7/2012 16:48'!
containsPoint: aPoint
	^ (self bounds containsPoint: aPoint)
		and: [(self class form isTransparentAt: aPoint - bounds origin) not]! !

!ARDroneMorph methodsFor: 'initialize-release' stamp: 'Richo 8/7/2012 17:26'!
delete
	self isConnected ifTrue: [self disconnect].
	super delete.! !

!ARDroneMorph methodsFor: 'connection' stamp: 'Richo 8/7/2012 17:25'!
disconnect
	self flag: #Richo! !

!ARDroneMorph methodsFor: 'drawing' stamp: 'Richo 8/7/2012 15:14'!
drawOn: aCanvas
	aCanvas translucentImage: self class form at: self bounds topLeft! !

!ARDroneMorph methodsFor: 'actions' stamp: 'Richo 8/7/2012 15:18'!
emergency
	self flag: #Richo.
	rotors do: [:each | each stop]! !

!ARDroneMorph methodsFor: 'accessing' stamp: 'Richo 8/7/2012 15:15'!
extent: newExtent
	super extent: self class form extent! !

!ARDroneMorph methodsFor: 'initialize-release' stamp: 'Richo 8/7/2012 15:14'!
initialize
	super initialize.
	self extent: 0@0;
		initializeRotors! !

!ARDroneMorph methodsFor: 'initialize-release' stamp: 'Richo 8/7/2012 15:20'!
initializeRotors
	| positions |
	positions := {74 @ -74. 74 @ 74. -74 @ 74. -74 @ -74}.
	rotors := (1 to: 4) collect: [:index || rotor |
		rotor := ARRotorMorph new
			center: self center + (positions at: index).
		index even 
			ifTrue: [rotor rotateClockwise]
			ifFalse: [rotor rotateCounterclockwise].
		self addMorphBack: rotor.
		rotor]! !

!ARDroneMorph methodsFor: 'connection' stamp: 'Richo 8/7/2012 17:26'!
isConnected
	self flag: #Richo.
	^ false! !

!ARDroneMorph methodsFor: 'actions' stamp: 'Richo 8/7/2012 15:26'!
land
	self flag: #Richo.
	rotors do: [:each | each stopGently]! !

!ARDroneMorph methodsFor: 'initialize-release' stamp: 'Richo 8/7/2012 17:26'!
newPlayerInstance
	^ ARDronePlayer newUserInstance! !

!ARDroneMorph methodsFor: 'actions' stamp: 'Richo 8/7/2012 15:18'!
takeOff
	self flag: #Richo.
	rotors do: [:each | each start]! !

!ARDroneMorph methodsFor: 'viewer category filter' stamp: 'Richo 8/7/2012 17:26'!
validCategories
	"Returns valid categories for the ARDrone object"
	^(self class additionsToViewerCategories collect: [:each| each first])! !

Morph subclass: #ARRotorMorph
	instanceVariableNames: 'clockwise speed state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARDrone-Etoys'!

ARRotorMorph class
	instanceVariableNames: 'form flippedForm'!

ARRotorMorph class
	instanceVariableNames: 'form flippedForm'!

!ARRotorMorph class methodsFor: 'instance creation' stamp: 'Richo 8/7/2012 14:19'!
clockwise
	^ self new 
		rotateClockwise;
		yourself
		! !

!ARRotorMorph class methodsFor: 'instance creation' stamp: 'Richo 8/7/2012 14:20'!
counterclockwise
	^ self new 
		rotateCounterclockwise;
		yourself
		! !

!ARRotorMorph class methodsFor: 'form' stamp: 'Richo 8/8/2012 16:22'!
flippedForm
	"
	flippedForm := nil
	"
	^ flippedForm ifNil: [flippedForm := self form 
			flipBy: #horizontal centerAt: self form center]! !

!ARRotorMorph class methodsFor: 'form' stamp: 'Richo 8/7/2012 13:51'!
form
	"
	form := nil
	"
	^ form ifNil: [self initializeForm]! !

!ARRotorMorph class methodsFor: 'form' stamp: 'Richo 8/7/2012 15:09'!
initializeForm
 ^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAABQAAAB0CAYAAACFfRJXAAANa0lEQVR42qWaWVCUVxbHeZ3K
e+YpM0bFnUV2QWl2wZ1ha2THBaPsBEQ2RTSIH6IxyahJalwIIRr3BQVCsSlS1iQKYqKWISkz
eZqpPKQqNamZDHfO77Yfg4bYX9d01Vdg0vz6nHvOPed/z203t2le3377bfCePXs+LygomKir
q5l4973DE+2ftE3c6OyY6Onp6tqyZcurbq68Hj58aFRXV6uIiAgVGRmuoqIjVHi4TT8rV8ap
goJtV4eHh39vGfj48eNJYEREuAqPsKlQ21K1LDREQyt3VKjhO0PNLlm4Y8cO+eNwAYZpK01g
WFioerO8VPX391oHjoyMGOXl5dMDw0NV2Zslqre/xzrwzp07RllZmQaGh4dpKEAefi8tLVY9
Pd3WgX19fUZRUZHDQrEuMipcW2azLdPAktIi1dV1wzrw2rVrxtatWx1RjoqYjDJAAlRcXKhu
3OiwDjx//ryRl5engcuXR6uY5VHaMluYWBgZpoqKClRHx1XrwOPHjxu5ubkaGB0TqYFRYinW
AS4syldXr162Djx48KCxfv16vYYxMVHaSoA64rKeBYXb1OXLl6wDa2trjcTERA0EFhsbo6Kj
IzWM9cwvAHjBOjA/P99YvXq1JHGYWBgj0OXyEysjBRwlWy9fgC64nJWVZcTGxkpUbRrI7zzR
0dH6kaIha+hCUOLj4w0CsmzZMg2Mi4tTK1as0FCsLSwsdA0oEAPrTCCwlStXajBQLLTs8tOn
TwPkDwaCg4O1y1gEbNWqVRoM1CXg/fv3i+vq6n4JDAyc1kKXgbdv3y7dvn278vPzU0uXLtVB
MNfQdFmyQF26ZDEPZduVbtu2TQUEBKiQkBBJlSgNwmXTSv7/uXPnrAE//PDD0g0bNih/f3/F
Ov7fwH379pWmpqYqX1/fSZdxl0QHagI//fRTa8BSea1Zs0b5+PhoC18E8rtLwPT09FLcfBHI
hwDFbWrl6dOnrQHlj0sJhgmMjIzUbppArHQJuHRpcKm/v58GhoQ4goJVa9euVevWrdNggO3t
7c6B4+PjSYcOtfxr8WIvxbNkSaB2GauAyR7XPy0DBwZ67XU7a5Sn5yLl7e05CcRVYNTIhIQE
ndiWgKfajtupxos8Figvbw+1JDhQuwwQUHJysoay9SwB9+3ba8/MSleLFgnQy0OCEvQc0G63
ayjly1JQSkoK7fF/WqsWLpyvPL0WaSAuEwgsI+FTUlKsA1PWp9jpGRro6QBSvggElqWlpWkr
EQGWgJJz9qCgALVgwTwNZA1jYx1ALKMT8rO4uNj5ThEJ53306JEHBGP+/Lm/AmIZQH6WlJQ4
B46OfmE7cvQ9tWDhvN8E4jLrKNvdebUZGBiwHThgqDlzZqu589yVh+fCSSA5aAKxEmXmFHj5
8nnbrl11yt19lpozd7ZOHdaTFgAQy6RwaCja0WkLOHXqL7byijI1232mtnLhovkqMMhfN3bT
ZYA8FRUVzttoS0uL7Y038hwWPgMGBPpptTAVmJGRoSorK0XOOdGH9fW1tuycTOU+x+EyQH9/
X12+XgRWVVWJgnUiiUWk29LT16tZs17XVpKL0wEzMzNVTU2NiPZ+a8CZM2eoWbNf16mjgS+4
LLpHSd9WQ0NDzlyut+XmZmsLZ86a8RyQ4goQd7OzszVQhL3zKFdUvKmtA0gu+vou1ioWIGmT
k5OjLdy1a5e6d++es50yajt27IiaN2+OdnvuXHflvdhTi06AJDRA1nD37t1KJIvz4hAbG20P
DPRXr8/8o440NRHBRPmi2gDjkYOlevTokXNgy9st9qzsDG3h7NkzlYfHQt2oaKPUQ3YJ67h3
71715MkT58B79/66dPfuXSP0E5Kb/RwUFKTbaFJSknYbCwX48zfffFNvqY2+//7R0vSM9Wre
/DmOirNkiVZcAM1IS5R/fPDgwQ6nsK6uLu+PPjrZm5mZrssYBQJ9QxsFRqRxm+A0NDTcuXjx
YolYOmP6tPnk1PzmA/tvpdiT1KTLsoZEmSoNhAcLaVyhoaFonB+uXLnSLRGf/xxMttFrJ0+e
GI2LW658fL1VRmaaampq1OcTDuBYtWXLFt2PyUOijkzx8vLSHyKHzfvff//9a5PA8vJC95yc
LL0zqqt3qO7uzoaxsdG6+Pi1/yCNGAts2Jijtkg1yshIE4sTL+7cWbs7KSlB+S72VnmbN1Ij
3aesW+t/KKac4YaHb+l0ePq38WZx/yckCafQhASp2qnJko+00+SPeY/RtM9YLR/msXCBunjh
3IQc3F/B3cHEpEQpAGt+lmPtu/9LobttGzfm6qrNwzmP896KlbEqNc3+sfm+murKj6Iiwife
yNusrl+/PsOttbV1AvmbYk/snbquN2/2t23atEFOAiEaGBwSpB/GBenpqZPAp+PjVelpqT+s
kN7z4P7oiJvUtglfXx8VG7d8LDA4MDEsbFliTFxM4uF3Dg0kJSdoCMGR9XSc6OW8nJObNXjm
THtiR0dHYqc8G3NzHsQtj1E3B/uV256Ghgk/Afr6eCt/P59JazjBi1bU/6aS5+Vt0hMRDuEp
KUnSm4t0AGvkiV+3Ronb6tixo8qtva11gkjxCVWV2+WpkDcXqoTEeD0Fwaqi4gJJ7GQNZ5CB
XOFDkXt+/j76CQoK1GnldkmiExTgp9JS7WMdV66IG1cScScnN3sA9wDiLm4DYRkOv/P2IMvC
8rBMkr8PODW89dZbym3o5sBP4bZQZU9O+oEFNhc7LSO1jQCYwcA6AkSgBgf7P54awGR7Up9/
gD+nK+V25PDhAFlUJdCJ6qrKNvNNkhptpIg5GjDTh1QaGbk7CRSP3lkXv+ZniodswWtug4OD
f7hw/uzEIulyJOn+pkad2LJmbSQxyUxS4zpJTrI/fTp+gPcMDw8ZrG/QkgDF5ujs7Hzl2dYr
d8/btFH5SHCSZTvVy7ZKTk66wDZju7HtVq1aodiGsp5/f/hwrPazz7rqa2qq9HalubF9J9dA
qu9rvb299xmteHp66o1PAaAQEDkKAwWCQkFwmvY3KkochSQ2LkadPHl8lALzXMUZGxtbIHql
m5JEH6FEUarMskU9pJRR0iht6Ejysbl5/xClb9qaSLGUSJVKV7sDxNSDwCiyFFuKLsWXEtfa
erKvu7tjsdPKLdZW7ty580csBEYEaQO0A9oC7QGVIW23zFJfEUt3SSP6Jw2JxgSQRkXDonHh
MlW9vn7nCI3NKVCCZJD1WIjbtFBaKS2VNaTF0mqzsjLUwYPNqZZGpjRzs7HT5Ik6waL5IwIQ
A6SRiAPnQMl4A7kBjODgNnKEKCNPkClYiGxBvnz55WjoS4F37941RI3pPARIpAEinBBQCCkE
FcIKgYXQcjqDlShr6WZGGiDSjp2B1NNAkX7sEqTgS4EiJg00IBYiMgEiOqcCtewTt0mf6urt
oU6Hushe1vA5YKQDiFxGNmOhJaAIcgNhjrvTARH0RBqBn52dqWR5Xg6Udqgn7S8COWJw1NBA
SW6s5Chy6FDzy4FSJAzmX+ZBxwRyCOIwZAI5JJWXlzmPshy79OieXQKQtOF4xjGNqk2B0C6L
hRznONY5nWNzQCShzUM3QA6SHCjZz+QiVkr5Urdu9b/c5bNnzxocYU09aLpsAqk4pA5l7MiR
99To6OfOgRyypx66pwNSZP/85/e+HB8f93op8MyZMwZjgKljgReB5CLrGR0d4bw4nD59WgPN
QzfVBiADDQYbABl0oCBE2lkDMvnAMtaRekj5YuSigV4OIIqiuKzYGpDZDJZhJUMghkE0LoDU
RFKHoVFjU6NzYHt7u8E4CsuATgWyhgSDcRZjrdbWE9aA9GNAQMlBgLiM4qKfsI4M3voG+6wB
GYtOHfHRRk2gOQ5saWn+95Mnj1IsAZkREghgFFeGkrhMo2JYydBS+rS1NkpQAGIVrgKmjVK+
kCmO6WcI/806EJexygTSRh1p4wA+kyrWgOwUgEBMK18E8iGyPV0DmhP2qUD0DfKXhG9qarIG
pDiYQPPqg98diR2sx/qM9z/44ANrQOrhbwEJBhcPz+4DrAHlHKwTG8U19erDdJmrEeZft2/f
tgakBbD1zAsZrARKC+DShsub2traX0T2lbgMNCMNlPKFYGIdxYPB7777LtAykGpjuvyihc/u
qqzfmtFGAWIRUHMNTSAqTLaka0BcNi8GzYtCgOZNmuge60DHGubrxo5a4BrTcZ0Zo683SXT5
QFeAFw2KJz2DC1YuWjmfcPGKu9RJEVOuAQsL8zXMHA3oi+uYKA1k2x0SQePCGl42uOUGxiU1
QC6tubxGxXLiOnHihHXg9etXHcDIZ9foAgaIlQA3b95s/RrOAbxmcLGPdfqiP9z2bD0jNJDi
29HhwqV/Z+d1g+8y6It+AfKVBL2ekeF6DenZcti0Duzp6Rb1VfKrL0zwJQqACCmnM9jnNXaP
wdc3sIxBBkDGBQ5ouB7dj4yMuAAc6DVQpoxVpgMily2NTM3X8J0hY0fVdh0ME+j4jkO4DgqC
/vHjxy59m+XVgoKtV5nKmV/c0VGOdAD5Ls5XX31lHchLjrS/++Lu5wMDg33q/IWz0j+OqYaG
eh2QxsbGga+//tpjur/7L4PhH9LnUB1iAAAAAElFTkSuQmCC'! !

!ARRotorMorph methodsFor: 'geometry testing' stamp: 'Richo 8/8/2012 16:25'!
containsPoint: aPoint
	^ (self bounds containsPoint: aPoint)
		and: [(self form isTransparentAt: aPoint - bounds origin) not]! !

!ARRotorMorph methodsFor: 'drawing' stamp: 'Richo 8/8/2012 16:22'!
drawOn: aCanvas
	aCanvas translucentImage: self form at: bounds topLeft! !

!ARRotorMorph methodsFor: 'accessing' stamp: 'Richo 8/7/2012 16:46'!
extent: newExtent
	super extent: self class form extent! !

!ARRotorMorph methodsFor: 'drawing' stamp: 'Richo 8/8/2012 16:22'!
form
	^ clockwise
		ifTrue: [self class form]
		ifFalse: [self class flippedForm]! !

!ARRotorMorph methodsFor: 'initialization' stamp: 'Richo 8/7/2012 16:52'!
initialize
	super initialize.
	clockwise := true.
	state := #stopped.
	speed := 0.
	self extent: 0@0.
! !

!ARRotorMorph methodsFor: 'accessing' stamp: 'Richo 8/7/2012 16:52'!
maxSpeed
	^ 46! !

!ARRotorMorph methodsFor: 'accessing' stamp: 'Richo 8/7/2012 16:56'!
minSpeed
	^ 0! !

!ARRotorMorph methodsFor: 'motion direction' stamp: 'Richo 8/7/2012 14:20'!
rotateClockwise
	clockwise := true! !

!ARRotorMorph methodsFor: 'motion direction' stamp: 'Richo 8/7/2012 14:21'!
rotateCounterclockwise
	clockwise := false! !

!ARRotorMorph methodsFor: 'start/stop' stamp: 'Richo 8/7/2012 17:03'!
start
	state := #starting! !

!ARRotorMorph methodsFor: 'stepping' stamp: 'Richo 8/8/2012 16:25'!
step
	state caseOf: {
		[#started] -> [speed := self maxSpeed].
		[#stopped] -> [speed := self minSpeed. ^ self].
		[#starting] -> [speed = self maxSpeed
			ifTrue: [state := #started]
			ifFalse: [speed := speed + 1]].
		[#stopping] -> [speed = self minSpeed 
			ifTrue: [state := #stopped]
			ifFalse: [speed := speed - 1]].
	}.
	self heading: speed * (clockwise ifTrue: [1] ifFalse: [-1]) + self heading! !

!ARRotorMorph methodsFor: 'stepping' stamp: 'Richo 8/7/2012 14:06'!
stepTime
	^ 1! !

!ARRotorMorph methodsFor: 'start/stop' stamp: 'Richo 8/7/2012 17:03'!
stop
	state := #stopped! !

!ARRotorMorph methodsFor: 'start/stop' stamp: 'Richo 8/7/2012 17:02'!
stopGently
	state := #stopping! !

Object subclass: #ARDroneProtocol
	instanceVariableNames: 'seq steppingProcess commandSocket navDataSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARDrone-Core'!

!ARDroneProtocol methodsFor: 'connection' stamp: 'Richo 8/6/2012 17:53'!
connect
	self isConnected ifTrue: [^ self].
	self initializeVariables.
	navDataSocket := Socket newUDP
		setPeer: #(192 168 1 1) asByteArray
		port: 5554.
	commandSocket := Socket newUDP
		setPeer: #(192 168 1 1) asByteArray
		port: 5556.
	self exitBootstrapMode;
		startSteppingProcess! !

!ARDroneProtocol methodsFor: 'connection' stamp: 'Richo 8/6/2012 17:53'!
disconnect
	self isConnected ifFalse: [^ self].
	self stopSteppingProcess.
	commandSocket closeAndDestroy.
	navDataSocket closeAndDestroy.
	commandSocket := navDataSocket := nil.
	self initializeVariables! !

!ARDroneProtocol methodsFor: 'commands' stamp: 'Richo 8/6/2012 17:36'!
emergency
	self sendATREF: 290717952! !

!ARDroneProtocol methodsFor: 'commands' stamp: 'Richo 8/6/2012 17:45'!
exitBootstrapMode
	self sendATCONFIG: '"general:navdata_demo"' with: '"TRUE"'! !

!ARDroneProtocol methodsFor: 'initialize-release' stamp: 'Richo 8/6/2012 17:26'!
initialize
	super initialize.
	self initializeVariables! !

!ARDroneProtocol methodsFor: 'initialize-release' stamp: 'Richo 8/6/2012 17:54'!
initializeVariables
	seq := 0! !

!ARDroneProtocol methodsFor: 'connection' stamp: 'Richo 8/6/2012 17:53'!
isConnected
	^ commandSocket notNil! !

!ARDroneProtocol methodsFor: 'commands' stamp: 'Richo 8/6/2012 17:35'!
land
	self sendATREF: 290717696! !

!ARDroneProtocol methodsFor: 'private' stamp: 'Richo 8/6/2012 17:31'!
nextSeq
	^ seq := seq + 1! !

!ARDroneProtocol methodsFor: 'sending' stamp: 'Richo 8/6/2012 17:31'!
sendATCOMWDG
	self send: ('AT*COMWDG={1}' format: {self nextSeq})! !

!ARDroneProtocol methodsFor: 'sending' stamp: 'Richo 8/6/2012 17:46'!
sendATCONFIG: arg1 with: arg2
	self send: ('AT*CONFIG={1},{2},{3}' format: {self nextSeq . arg1. arg2})
! !

!ARDroneProtocol methodsFor: 'sending' stamp: 'Richo 8/6/2012 17:34'!
sendATREF: arg
	self send: ('AT*REF={1},{2}' format: {self nextSeq. arg})! !

!ARDroneProtocol methodsFor: 'sending' stamp: 'Richo 8/6/2012 17:53'!
send: commandString
	commandSocket sendData: commandString, String lf! !

!ARDroneProtocol methodsFor: 'stepping' stamp: 'Richo 8/6/2012 17:21'!
startSteppingProcess
	steppingProcess ifNotNil: [^ self].
	steppingProcess := [[self step. 
		(Delay forMilliseconds: self stepTime) wait] repeat]
			forkNamed: self asString.
! !

!ARDroneProtocol methodsFor: 'stepping' stamp: 'Richo 8/6/2012 17:56'!
step
	self sendATCOMWDG.
	Transcript show: navDataSocket receiveAvailableData; cr! !

!ARDroneProtocol methodsFor: 'stepping' stamp: 'Richo 8/6/2012 17:23'!
stepTime
	^ 30! !

!ARDroneProtocol methodsFor: 'stepping' stamp: 'Richo 8/6/2012 17:21'!
stopSteppingProcess
	steppingProcess ifNil: [^ self].
	steppingProcess terminate.
	steppingProcess := nil! !

!ARDroneProtocol methodsFor: 'commands' stamp: 'Richo 8/6/2012 17:35'!
takeOff
	self sendATREF: 290718208! !
